// Задача "Награды"
// Шестая Интернет-олимпиада сезона 2009-2010, усложненный уровень
// Автор задачи: Рустам Ганеев, ganeev@rain.ifmo.ru
// Автор решения: Сергей Поромов, poromov@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class grants_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new grants_sp()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "grants";
	
	int MAXN = 100000;

	public void solve() {
		int n = nextInt();
		int k = nextInt();
		int m = nextInt();
		myAssert((1 <= k) && (k <= n) && (n <= MAXN), "Wrong k or n");
		myAssert(BigInteger.valueOf(m).isProbablePrime(100), "Not a prime m");
		out.println(cnk(n - k + 1, k, m));
	}

	private long cnk(int n, int k, int m) {
		BigInteger M = BigInteger.valueOf(m);
		if (k > n) {
			return 0;
		}
		long res = 1;
		int cnt = 0;
		for (int i = k + 1; i <= n; i++) {
			int j = i;
			while (j % m == 0) {
				cnt++;
				j /= m;
			}
			res *= j;
			res %= m;
		}
		for (int i = 1; i <= n - k; i++) {
			int j = i;
			while (j % m == 0) {
				cnt--;
				j /= m;
			}
				res *= BigInteger.valueOf(j % m).modInverse(M).longValue();
				res %= m;
		}
		if (cnt > 0) {
			res = 0;
		}
		return res;
	}
}
